Object
	defineCFunc: 'ST_PerformMessage'
	withSelectorArgs: 'primPerform: message'
	returning: #smalltalk
	args: #(#self #smalltalk) !

Object
	defineCFunc: 'ST_PerformMessage1'
	withSelectorArgs: 'primPerform: message with: a'
	returning: #smalltalk
	args: #(#self #smalltalk #smalltalk) !

Object
	defineCFunc: 'ST_PerformMessage2'
	withSelectorArgs: 'primPerform: message with: a with: b'
	returning: #smalltalk
	args: #(#self #smalltalk #smalltalk #smalltalk) !

Object
	defineCFunc: 'ST_PerformMessage3'
	withSelectorArgs: 'primPerform: message with: a with: b with: c'
	returning: #smalltalk
	args: #(#self #smalltalk #smalltalk #smalltalk #smalltalk) !

Object
	defineCFunc: 'ST_PerformMessage4'
	withSelectorArgs: 'primPerform: message with: a with: b with: c with: d'
	returning: #smalltalk
	args: #(#self #smalltalk #smalltalk #smalltalk #smalltalk #smalltalk) !

Object
	defineCFunc: 'ST_PerformMessage5'
	withSelectorArgs: 'primPerform: message with: a with: b with: c with: d with: e'
	returning: #smalltalk
	args: #(#self #smalltalk #smalltalk #smalltalk #smalltalk #smalltalk #smalltalk) !

Object
	defineCFunc: 'ST_PerformMessage5'
	withSelectorArgs: 'primPerform: message with: a with: b with: c with: d with: e with: f'
	returning: #smalltalk
	args: #(#self #smalltalk #smalltalk #smalltalk #smalltalk #smalltalk #smalltalk #smalltalk) !

!Object methodsFor: 'objective-c performance'!

doesNotUnderstand: aMessage
	| args numArgs result |
	" CHECK - if class, and class is nil..."
	"self ifNil: [ ^super doesNotUnderstand: aMessage ]."
	self ifNil: [ ^MessageNotUnderstood new message: aMessage receiver: self; signal ].
	"Transcript show: ('-------------> %1' bindWith: aMessage selector); nl."
	"ObjectMemory quit."

	args := aMessage arguments.
	numArgs := args size.
	(numArgs = 0) ifTrue: [ result := self primPerform: aMessage ].
	(numArgs = 1) ifTrue: [ result := self primPerform: aMessage with: (args at: 1) ].
	(numArgs = 2) ifTrue: [ result := self primPerform: aMessage with: (args at: 1) with: (args at: 2) ].
	(numArgs = 3) ifTrue: [ result := self primPerform: aMessage with: (args at: 1) with: (args at: 2) with: (args at: 3) ].
	(numArgs = 4) ifTrue: [ result := self primPerform: aMessage with: (args at: 1) with: (args at: 2) with: (args at: 3) with: (args at: 4) ].

	^result.
!

!!
