// Copyright (c) 2004 Lyndon Tremblay. All Right Reserved. -*- mode: objc -*-

//#include <objc/objc.h>
#include <gstpub.h>

#if 1
#define MAX_SUBPROXIES 64
#define MAX_IVARS 16

#define PROXY_POOL_SIZE 1024

union STProxy
{
	struct objc_object object;
	//char buf[128];          // Class + OOP + OBJ_HEADER + varcount


	// errr.

#if 0
	char buf[sizeof(Class) + sizeof(OOP) +
			 //sizeof(mst_Object) +
			 sizeof(gst_object_header) +
			 sizeof(int) + (sizeof(STProxy) * MAX_SUBPROXIES) +
			 (MAX_IVARS * sizeof(OOP))];
#else
	char buf[PROXY_POOL_SIZE];
#endif
};

//#define ST_ProxyObject(p) ((STObject *)((id)&p.object))
#endif

////////////////////////////////////////

struct STObject_guts
{
	OBJ_HEADER;
	// ~_~
};

@interface STObject
{
@public // temp, use struct ? naw.
	//OBJ_HEADER;

	Class isa;
	OOP oop;

	//int subCount;
	//union STProxy subproxies[MAX_SUBPROXIES];
}

//+ (OOP)asOop;

+ (STObject *)proxy:(union STProxy *)proxy
			  class:(Class)class
			  using:(OOP)oop;

+ alloc;
- free;

- yourself;

- (Class)class;
//- (OOP)oopClass;
//- (STObject *)proxyFor:(OOP)object;

- subclassResponsibility:(SEL)aSel;
- notImplemented:(SEL)aSel;
- shouldNotImplement:(SEL)aSel;
- doesNotRecognize:(SEL)aSel;

- (Method_t)methodFor:(SEL)aSel;
- (retval_t)forward:(SEL)aSel :(arglist_t)argFrame;
- perform:(SEL)aSel;
- perform:(SEL)aSel with:(id)anObject;
- perform:(SEL)aSel with:(id)anObject with:(id)anotherObject;

- error:(const char *)aString, ...;

@end

//////////////////////////

#define STGuts(Type,o) ((struct Type##_guts *)oopToObj(o))
#define STGetIvar(ct,Type,n) (VMp->OOPTo##Type(STGuts(ct,self->oop)->n))
#define STSetIvar(ct,Type,n,x) (STGuts(ct,self->oop)->n = VMp->Type##ToOOP(x))

/////////////////

@interface UndefinedObject : STObject
@end
