// Copyright (c) 2004 Lyndon Tremblay. All Right Reserved. -*- mode: objc -*-

#include <objc/encoding.h>

@interface Smalltalk : STObject

- initWithArgc:(int)argc argv:(char **)argv;
//+ vm;

- interpret;
- (OOP)evaluate:(char *)format, ...;    // one day be (id) and proxy'd
- backtrace;
//- exception:(char *)name signal:(char *)format, ...;

- fileIn:(char *)fileName;
//- (OOP)objectIn:(char *)fileName;        // fill this in

//- (id)allocObjectForOOP:(OOP)object;
- (char *)classNameOf:(OOP)object;
//- (Class)classOf:(OOP)object;

- (char *)selectorNameOf:(OOP)message;
- (SEL)selectorOf:(OOP)message;

- (OOP)performMessage:(OOP)message on:(OOP)oop args:(OOP)oarg,...;
- (OOP)lookupMessage:(OOP)message on:(OOP)object into:(struct STMessage *)message;

/////

- forEachSubStringIn:(char *)string do:(SEL)selector on:(id)object;

@end

extern VMProxy *VMp;

//#define ST [GST vm]
extern Smalltalk *ST;

//#undef st
//#define st(k)  k __attribute__((unused))
