// Copyright (c) 2004 Lyndon Tremblay. All Right Reserved.
//#include <Main.h>

//#include <Valhalla/Valhalla.h>
#include <Core/Core.h>

// augh SDL
#ifdef main
#undef main
#endif

@implementation SingletonObject
@end

@implementation Rectangle
@end

@implementation Point
- (id)vertex
{
	glVertex2f([self x], [self y]);
	return self;
}
@end

int main (int argc, char **argv)
{
	int stc = 1;
	char *stv[] = { argv[0],
					//"-c",
					//"-L", PROJECT_NAME".changes",
					//"-I", PROJECT_NAME".im",
					NULL };

	ST = [[Smalltalk alloc] initWithArgc: argc argv: argv];
	//ST = [[Smalltalk alloc] initWithArgc: stc argv: stv];

	printf("---- ProjectName: %s version: %s ----\n", PROJECT_NAME, PROJECT_VERSION);

	[ST evaluate: "ObjectMemory gcMessage: false. FileStream verbose: true!"];
	[ST evaluate: "Smalltalk at: #ProjectName put: '"PROJECT_NAME"'!"];
	//[ST evaluate: "Smalltalk at: #ProjectVersion put: '"PROJECT_VERSION"'!"];

	char *preload[] = {
		//"KernelAdditions.st",
		"Makefile.st",
		//"ClassExporter.st",
		
		"ObjCBridge.st",
		"CommandEnvironment.st",

		//"TMSourceFile.st",
		//"TMOut/TMOut.st",
		"StmSourceFile.st",
		"StmOut/StmFileIns.st",

		NULL
	};

	for (int i=0 ; preload[i] ; i++)
		[ST fileIn: preload[i]];

	[ST evaluate: "Smalltalk at: #Project put: "
		"(Makefile projectIn: 'Project-"PROJECT_NAME".h')!"];

	[ST evaluate: "Project startup!"];
	//#define PROJECT_STARTUP "Project smalltalkFiles do: [ :ea | FileStream fileIn: ea ]!"

	//[ST evaluate: "FileStream evalString: (Project startupCode)"
	//"on: nil ifError: []!"];

	//[ST forEachSubStringIn: PROJECT_SMALLTALK do: @selector(fileIn:) on: ST];
	//[ST evaluate: PROJECT_STARTUP];

	// temp T_T
	//[MapServer serveUsingArgc: argc argv: argv];
	///a_main(argc, argv);
	///[ST evaluate: "Server serveUsingArcgc..."];

	//[ST evaluate: "Smalltalk at: #System put: (SDL new)!"];
	[[ST interpret] free];
	return 0;
}
